/*--------------------------------------------------------------------
	nxeditor
			FILE NAME:block.c
			Programed by : I.Neva
			R & D  ADVANCED SYSTEMS. IMAGING PRODUCTS.
			1992.06.01

    Copyright (c) 1998,1999,2000 SASAKI Shunsuke.
    All rights reserved. 
--------------------------------------------------------------------*/
#include "ed.h"


#define	MAX_bbuf	1024


int 	GetBlockFlg()	{return blkmd.flag;}

bool	block_ismode()
{
	if (!blkmd.flag)
		return FALSE;
	return blkmd.start!=blkmd.end;
}

long	GetBlockStart()
{
	if (blkmd.start<=blkmd.end)
		return blkmd.start;
	return blkmd.end;
}

long	GetBlockEnd()
{
	if (blkmd.start==blkmd.end)
		return blkmd.start;

	if (blkmd.start<blkmd.end)
		return min(GetLastNumber(),blkmd.end-1); // äminϤʤ?
	return min(GetLastNumber(),blkmd.start-1);
}

void	block_set()
{
	blkmd.end = GetLineOffset();
}


typedef	struct
{
	int 	nums;
	char	*s[MAX_bbuf];
}	bbuf_t;

bbuf_t	bbuf;

void	bbuf_init()
{
	bbuf.nums=0;
}

void	bbuf_fin()
{
	int 	i;
	for (i=bbuf.nums;i>0;)
		free(bbuf.s[--i]);
	bbuf.nums=0;
}

void	bbuf_copy_proc(const char *s,char *gp)
{
	if (gp!=NULL)
		strcat(gp,s);
}


bool	bbuf_copy(long n_st,long n_en)
{
	char	*p;

	if (n_st == GetLastNumber() && *csrle.buf=='\0')
		return FALSE;


	if (bbuf.nums>=MAX_bbuf)
		{
		 if (!keysel_ynq("֥åХåեդǤޤ?"))
		 	return FALSE;
		 bbuf_fin();
		}

	p= (char *)mem_alloc(lists_size(n_st,n_en));
	bbuf.s[bbuf.nums++]=p;
	*p='\0';
	lists_proc(bbuf_copy_proc, p, n_st, n_en);

	csrse.bytes+=lists_size(n_st, n_en);

	return TRUE;
}



void	BlockInit()
{
	blkmd.start = 0;
	blkmd.end = 0;
	blkmd.flag = FALSE;
}

SHELL	void	op_block_start()
{
	csr_leupdate();

	if (blkmd.flag)
		BlockInit(); else
		{
		 blkmd.flag= TRUE;
		 blkmd.start= GetLineOffset();
		 blkmd.end= GetLineOffset();
		}
}

bool	BlockCommand()		/* ֥åޥɤν */
{
	csr_leupdate();

	if (!blkmd.flag)
		blkmd.start=blkmd.end=GetLineOffset(); else
		{
		 blkmd.flag= FALSE;
		 if (blkmd.start==blkmd.end)
		 	return FALSE;
		}

	return lists_size(GetBlockStart(),GetBlockEnd())>0;
}


SHELL	void	op_block_yanc()	/* ֥å򥳥ԡΤߡ*/
{
	if (!BlockCommand())
		return;
	bbuf_copy(GetBlockStart(), GetBlockEnd());
}

void	block_cut(long n_st,long n_ed)
{
	csrse.bytes-= lists_size(n_st,n_ed);
	lists_delete(n_st,n_ed);
	SetFileChangeFlag();
	csr_lenew();

	csr_setdy(GetRow()+n_st-GetLineOffset());
	csr_setly(n_st);
}

SHELL	void	op_block_cut()
{
	long	n_st,n_ed;

	if (!BlockCommand())
		return;

	n_st=GetBlockStart();
	n_ed=GetBlockEnd();

	if (!bbuf_copy(n_st,n_ed))
		return;
	block_cut(n_st,n_ed);
}


void	*bbuf_paste_proc(char *s, char *gp)
{
	while(*gp!='\0'&& *gp!='\n')
		*s++=*gp++;
	if (*gp=='\n')
		++gp;
	*s='\0';
	if (*gp=='\0')
		gp=NULL;
	return gp;
}

void	bbuf_paste()
{
	if (bbuf.nums==0)
		return;

	csr_leupdate();

	lists_add(bbuf_paste_proc, bbuf.s[bbuf.nums-1]);

	SetFileChangeFlag();

	csr_lenew();
	OffsetSetByColumn();
}

SHELL	void	op_block_paste()
{
	bbuf_paste();
	if (bbuf.nums>0)
		--bbuf.nums;
}	

SHELL	void	op_block_copy()
{
	bbuf_paste();
}

SHELL	void	op_block_dup()
{
	if (!BlockCommand())
		return;

	bbuf_copy(GetBlockStart(),GetBlockEnd());
	op_block_paste();
}

SHELL	void	op_block_kill()
{
	if (keysel_ynq("󥯥Хåեޤ"))
		bbuf_fin();
}

SHELL	void	op_block_chlast()
{
	long	a;

	if (blkmd.flag)
		{
		 a=blkmd.start;
		 blkmd.start= GetLineOffset();

		 csr_setly(a);
		}
}

